/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package cz.muni.fi.pb162.cars;

/**
 *
 * @author bar
 */
public class GarageImpl implements Garage {
	private int engaged=0;
	private Car[] places;

	public GarageImpl(int capacity) {
		places = new Car[capacity];
	}

	public int getCapacity(){
		return places.length;
	}
	
	public int getEngaged(){
		return this.engaged;
	}

	public int getFreeCapacity(){
		return getCapacity()-getEngaged();
	}

	public boolean parkCar(Car car)
	{
		boolean parked = false;
		if (getFreeCapacity() > 0 ){
			if(!isAllReadyInGarage(car)){
				places[engaged] = car;
				engaged ++;
				parked = true;
			}
		}
		return parked;
	
	}
	

	private boolean isAllReadyInGarage(Car car){
		boolean contained = false;
                for (int i=0; i<engaged && !contained; i++ )
                   {
                      contained = places[i].equals(car); 
                   }
                return contained;  
       }

		
	public boolean leaveCar(Car car){
		boolean left=false;
                int position = getPosition(car);
		

		if (position >= 0) {
			removeCar(position);
			engaged --;
			left = true;
		} 	
		return left;
	}

	private int getPosition(Car car){
		int pos=-1;
		int i;		
		boolean found = false;

		for (i = 0; i < engaged && !found; i++){
			if(places[i].equals(car)){
				pos = i;
				found = true;
			}
			
		}
			
		return pos;
	}
	
	private void removeCar(int pos){
	
		Car[] newPlaces= new Car[places.length];
		
		for(int i = 0 ; i < newPlaces.length ; i++){
			if(i<pos) {
				newPlaces[i] = places[i];
			}else{
			  if(i>pos){
					newPlaces[i-1] = places[i];
			  }
			}
		}
		places = newPlaces;
	}


	public String toString(){
		StringBuffer retVal= new StringBuffer("Garage: [");

		for (int i = 0; i < engaged ; i++){
			retVal.append(places[i]);
			if(i< engaged - 1){
				retVal.append(", ");
			}else{
				retVal.append("]");
			}
		}
	
		return retVal.toString();
	}
}
